"""
    
    This is a simple test framework that illustrates Data Driven Test concept
    using Selenium. For details please check "DDT with Selenium" article in
    on http://coremag.eu - CoreMag issue 4/2010   
    
    Please remember to start Selenium RC server befor rinning this script

    Usage:
    
    py.test.exe SampleTest.py

"""

from selenium import selenium
from xlrd import open_workbook,cellname

seleniumHost = 'localhost'
seleniumPort = str(4444)
browserStartCommand = "*firefox"
browserURL = "http://localhost/"
timeout = 5000

xlfilename = 'SampleTests.xls'
xlsheetIndex = 0

def pytest_generate_tests(metafunc):

    headers = []
    book = open_workbook(xlfilename)
    sheet = book.sheet_by_index(xlsheetIndex)
    cols, rows = sheet.ncols, sheet.nrows
    data = [[None] * cols for i in range(rows-1)]
    for row_index in range(rows):
        for col_index in range(cols):
            if row_index == 0:
                headers.append(sheet.cell(row_index,col_index).value)
            else:
                data[row_index-1][col_index] = sheet.cell(row_index,col_index).value
    
    for r in range(rows-1):
        d = {}
        n = 2
        for i in headers[2:]:
            d[i] = data[r][n]
            n = n + 1
        metafunc.addcall(funcargs=dict(actions=d))


def test_actions(actions):

        not_clickable = ['url', 'action', 'result']
        
        sel = selenium(seleniumHost, seleniumPort, browserStartCommand, browserURL)
        sel.start()
        sel.open(actions["url"])
        for k, v in actions.iteritems():
            if ( not k in not_clickable ):
                sel.type(k, v)
        sel.click(actions['action'])
        sel.wait_for_page_to_load(timeout)
        assert sel.is_text_present(actions['result'])
        sel.stop()
